// -*- mode: C++; tab-width: 4; indent-tabs-mode: nil -*- (for GNU Emacs)
//
// Copyright (c) Microsoft Corporation
//
// This file is part of the Microsoft Research Mesh Connectivity Layer.
// You should have received a copy of the Microsoft Research Shared Source
// license agreement (MSR-SSLA) for this software; see the file "license.txt".
// If not, please see http://research.microsoft.com/mesh/license.htm,
// or write to Microsoft Research, One Microsoft Way, Redmond, WA 98052-6399.
//

typedef int boolint;
typedef unsigned int uint;
typedef unsigned short ushort;
typedef unsigned char uchar;
typedef struct AckBitMap AckBitMap ; 



//uint is 4 bytes..need 8 for 256-sized bitmap
#define NUMACKBITMAP 8 

struct AckBitMap {
	uint bm[NUMACKBITMAP] ; 
};

//sizeof(XXX) must be the same as AckBitMap.bm
#define BITMAPLENGTH (sizeof(uint)*8*NUMACKBITMAP)


//
// Definitions for time in 100ns units.
//

typedef ULONGLONG Time;

#define MAXTIME ((Time) (LONGLONG) -1)

#define TENTHMICRO	(1)
#define MICROSECOND (10)
#define MILLISECOND (1000 * MICROSECOND)
#define SECOND      (1000 * MILLISECOND)
#define MINUTE      (60 * SECOND)
